package com.terraformersmc.terrestria.feature.trees;

import com.mojang.datafixers.Dynamic;
import com.terraformersmc.terrestria.feature.TreeDefinition;
import com.terraformersmc.terrestria.feature.trees.templates.JapaneseTreeFeature;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2410;
import net.minecraft.class_3111;
import net.minecraft.class_3341;
import net.minecraft.class_3747;

public class JapaneseMapleTreeFeature extends JapaneseTreeFeature {
	public JapaneseMapleTreeFeature(Function<Dynamic<?>, ? extends class_3111> function, boolean notify, TreeDefinition.Basic tree) {
		super(function, notify, tree);
	}

	public JapaneseMapleTreeFeature sapling() {
		return new JapaneseMapleTreeFeature(class_3111::method_13565, true, tree);
	}

	@Override
	public void placeGroundCover(Set<class_2338> blocks, class_3747 world, class_2338.class_2339 origin, double maxRadius, Random rand, class_3341 boundingBox) {
		method_12773(blocks, world, origin.method_10074(), class_2246.field_10566.method_9564(), boundingBox);
	}

	@Override
	public void placeBranch(Set<class_2338> blocks, class_3747 world, class_2338.class_2339 pos, int length, class_2350 direction, class_3341 boundingBox) {
		for (int i = 0; i < length - 1; i++) {
			pos.method_10098(direction);
			method_12773(blocks, world, pos, tree.getLog().method_11657(class_2410.field_11459, direction.method_10166()), boundingBox);
		}

		pos.method_10098(direction);
		tryPlaceLeaves(blocks, world, pos, boundingBox);
	}

	@Override
	public void correctLogStates(Set<class_2338> blocks, class_3747 world, class_3341 boundingBox) {
	}
}
